<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <v-row>
    <v-col>
      <v-card>
        <v-card-title>
          Gruppen
          <v-spacer></v-spacer>
          <v-switch v-model="showOwn" label="Nur eigene Gruppen"></v-switch>
          <v-spacer></v-spacer>
          <v-switch v-model="showImplicit" label="Implizite Mitglieder"></v-switch>
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Search"
            single-line
            hide-details
          ></v-text-field>
        </v-card-title>
        <group-list
          :groups="groups"
          :users="users"
          :loading="loading"
          :groupSelection="
            showOwn
              ? showImplicit
                ? allImplicitGroups(applicationStore.session.user.groups)
                : applicationStore.session.user.groups
              : undefined
          "
          :showImplicit="showImplicit"
          :search="search"
          showDetailsLink
        />
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import Api from '../../LegacyApi';
import Util from '../../LegacyUtil';
import { useApplicationStore } from '../../stores/application';

export default {
  methods: {
    allImplicitGroups: function (groupIds) {
      return Util.allImplicitGroups(groupIds, this.groups);
    },
  },
  mounted() {
    Api.defaultHandler(this, Promise.all([Api.getAllGroups(), Api.getAllUsers()])).then(
      (result) => {
        this.groups = result[0];
        this.users = result[1];
        this.loading = false;
      }
    );
  },
  data: () => {
    return {
      search: '',
      showOwn: false,
      showImplicit: false,
      loading: true,
      groups: new Map(),
      users: new Map(),
      applicationStore: useApplicationStore(),
    };
  },
  beforeUnmount() {
    this.$emit('clearError');
  },
};
</script>
